import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Setting, SettingParam } from './model';
import {SERVER_API_URL} from "@/utils/server";

/**
 * 分页查询设置
 */
export async function pageSetting(params: SettingParam) {
  const res = await request.get<ApiResult<PageResult<Setting>>>(
    SERVER_API_URL + '/system/setting/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询设置列表
 */
export async function listSetting(params?: SettingParam) {
  const res = await request.get<ApiResult<Setting[]>>(
    SERVER_API_URL + '/system/setting',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询
 */
export async function getSetting(id: number) {
  const res = await request.get<ApiResult<Setting>>(
    SERVER_API_URL + '/system/setting/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加设置
 */
export async function addSetting(data: Setting) {
  const res = await request.post<ApiResult<unknown>>(
    SERVER_API_URL + '/system/setting',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改设置
 */
export async function updateSetting(data: Setting) {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/system/setting',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除设置
 */
export async function removeSetting(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    SERVER_API_URL + '/system/setting/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除设置
 */
export async function removeBatchSetting(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    SERVER_API_URL + '/system/setting/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    SERVER_API_URL + '/system/setting/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}
